/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Aug 2009

 File          : ViewADI_OSC_REF.c

 Hardware      : Applicable to ADuC7038

 Description   : This routine Sets the ECLK on GPIO_5.

	Oscillator	 This clock is 2.56MHZ nominal - 20 x the 128KHz oscillator
				 The user can vary	POWCON to set the Low power Oscillator - 3%
				 or the Precision oscillator - 1%  , measure the 2.56MHZ clock 
				 and Divide by 20 for 128KHz measurement. 

*********************************************************************/

#include <ADuC7038.h>

void delay(int);
unsigned int Any_status	= 0;
char HVstatus;
void LIN_INIT(void );

int main()
{
	unsigned long it1=1234, it2=4321;
// 	FIQ = My_FIQ_Function; 	// Initialise Interrupt Routine	 for LIN
//	FIQEN = 0x20;

	LIN_INIT();								// SET 10.24 MEg PLL
 	POWKEY0 = 0x01;		 			// Put all peripherals, PLL and Core Asleep
	POWCON	 = 0x179;				// 0001 0111 1001 default value is 79	- 10MHz	/ 1% prec
	POWKEY1 = 0xF4;					// 
	it1 = it1*it2;					// Dummy cycle to ensure correct power down 

    delay(20000);					// Delay after enabling 1% osc - PLLCON

  PLLKEY0 = 0x000000AA;
	PLLCON  = 0x01;        	 /* Intern 1% Oszillator  Precision   */
  PLLKEY1 = 0x00000055;
	it1 = it1*it2;			// Dummy cycle to ensure correct power down

	Any_status = PLLSTA;	// check Lock
	do 
		{
		Any_status = PLLSTA;
		}
	while ((Any_status & 0x02) != 2);

  
  	GPCON = 0x00200000;				//Enable (GPIO 5 as ECLK) and all others as ouputs.
									// View on Scope  - Divide by 20 for precision Measurment on 128 KHz clock
	GPDAT = 0x3F3f0000;				
 	GPSET = 0x00030000;				// View Pulse on Scope - ensures that PLL Lock occurred !
	GPCLR = 0x00030000;				// Set all bits to Zero

	while(1)				// Current Meas Test for Table 37 in ADuC7038
	{
	}    							// Infinite Loop
}

void delay (int length){
	while (length >=0)
    	length--;
}

void LIN_INIT(void )
{
// 	GPCON = 0x110000;			// enable LIN Rx and LIN Tx on GPIO
 	GPCON = 0x110000;			// enable LIN Rx and LIN Tx on GPIO
	do										
	{
		HVDAT = 0x05; 			// Enable Normal LIN TX / Renable 		
		HVCON = 0x08; 			// Write to Config
		do
		{
			HVstatus = HVCON;
		}
		while(HVstatus & 0x1); 		// Wait until BUSY is ready
	}	while (!(HVstatus & 0x4));		// transmit command 
	LINCON = 0x1800;			// Enable LIN

// LINWU = 0x0010;
// LINBK = 0x030;				// Set number of 131kHz periods to generate a Break Interrupt
}
